//生成用户数据
export function generateUsers() {
    const users = []
    //数据生成器
    for (let i = 0; i < 100; i++) {
        let user = {
            id: i,
            username: 'user' + (i + 3),
            password: '123456',
            auth: Math.floor(Math.random() * 3),
        }
        users.push(user)
    }
    return users
}

//生成动物数据
export function generateAnimals() {
    const animals = []
    //数据生成器
    for (let i = 0; i < 100; i++) {
        let animal = {
            id: i,
            name: 'animal' + (i + 3),
            sex: Math.floor(Math.random() * 2) === 0 ? '雌性' : '雄性',
            species: Math.floor(Math.random() * 10).toString(),//种类
            weight: Number((Math.random() * 2000).toFixed(2)),
            height: Number((Math.random() * 10).toFixed(2)),
            state: Math.floor(Math.random() * 2),//状态（0正常 1异常）
            roleId: Math.floor(Math.random() * 100),//饲养员id
            color: '',//Math.floor(Math.random() * 255),//颜色
            features: Math.floor(Math.random() * 40).toString(),//特征
            phase: generatePhase()
        }
        animals.push(animal)
    }
    return animals
}

// id: '',//int 饲养计划id
//     name: '',//字符 饲养计划名称
//     species: '',//字符 种类
//     sex: '雄性',//字符 饲养动物性别
//     phase: '',//字符 饲养动物阶段：幼年期、成长期、成年期、老年期
//     state: 0,//int 状态（0正常 1异常）
//     describe: ''//字符 饲养计划的描述

export function generateBreedingPlans() {
    const breedingPlans = []
    for (let i = 0; i < 100; i++) {
        let breedingPlan = {
            id: i,
            name: 'breeding' + (i + 3),
            species: Math.floor(Math.random() * 10).toString(),
            sex: Math.floor(Math.random() * 2) === 0 ? '雌性' : '雄性',
            phase:generatePhase(),
            state: Math.floor(Math.random() * 2),
            roleId: Math.floor(Math.random() * 100),
            description: Math.floor(Math.random() * 500).toString(),
        }
        breedingPlans.push(breedingPlan)
    }
    return breedingPlans
}

function generatePhase() {
    const phase = Math.floor(Math.random() * 4)
    if (phase===0)
        return '幼年期'
    if (phase===1)
        return '成长期'
    if (phase===2)
        return '成年期'
    if (phase===3)
        return '老年期'
}

export function generateArchives() {
    const archives = []
    for (let i = 0;i<100;i++){
        let archive={
            id: i,//档案号
            animalId: Math.floor(Math.random()*100),//该档案记录的动物id
            animalName: 'animal' + (i + 3),//该档案记录的动物名称
            phase:generatePhase(),
            state:Math.floor(Math.random() * 2),
            type:generateType(),
            date:'2024-'+Math.ceil(Math.random()*11).toString().padStart(2,'0')+'-'+Math.ceil(Math.random()*30).toString().padStart(2,'0'),//字符 档案记录日期
            time:Math.floor(Math.random() * 24).toString().padStart(2,'0')+':'+Math.floor(Math.random()*60).toString().padStart(2,'0')+':'+Math.floor(Math.random()*60).toString().padStart(2,'0'),//记录时间
            roleId: Math.floor(Math.random() * 100),//负责录入档案的人的id，身份不限
            description: Math.floor(Math.random() * 500).toString(),
        }
        archives.push(archive)
    }
    return archives
}
function generateType() {
    const type = Math.floor(Math.random() * 3)
    if (type===0){
        return '疫苗接种'
    }
    if (type===1){
        return '疾病治疗'
    }
    if (type===2){
        return '日常饲养'
    }
}

//深拷贝任何值
export function copy(value) {
    let result = JSON.stringify(value)
    return JSON.parse(result)
}

//鼠标悬浮显示密码
//region
export function showPassword(event,password){
    event.target.innerText = password
}

export function hidePassword(event) {
    event.target.innerText = '••••••••'
}
//endregion

//模糊查询
//region
//分割字符串
export function splitKeyWords(keyword) {
    let keyset = keyword.split(' ')//提取关键字
    keyset = Array.from(new Set(keyset))//关键字去重
    console.log('切割去重好的关键字', keyset)

    return keyset;
}

//模糊匹配，传入一个包含多个关键字的数组、一个对象，若匹配则true
export function fuzzyMatching(object, keyset) {
    //一个对象的所有属性能匹配所有关键字就返回true，every():遇到false就返回false，所有true就返回true
    return keyset.every(key => {
        return keywordMatching(object, key)
    })
}

//传入一个关键字，一个对象，只有关键字能匹配对象的某个属性，则true
function keywordMatching(object, keyword) {
    //该关键字为空，肯定能匹配上
    if (keyword === '') {
        console.log('keywordMatching关键字为空', object, keyword, true)
        return true
    }
    //只要对象的任意属性能匹配一次关键字就返回true，some():遇到true就返回true，所有false就返回false
    return Object.keys(object).some(key => {
        return (object[key] + '').includes(keyword)
    })
}
//endregion

//日期时间降序排序
export function sortByDateTime(archives) {
    archives.sort((a, b) => {
        return Number(b.date.split('-').join(''))-Number(a.date.split('-').join(''))
    })
    archives.sort((a, b) => {
        //日期相同再按时间排序
        if (a.date===b.date) {
            return Number(b.time.split(':').join('')) - Number(a.time.split(':').join(''))
        }
    })
}